<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "ncbi-taxon-sn-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    // For information, if you want to change data in control, you must use control.handleChange()
    let initialValue = control.control.value.data;
    if (control.control.value.data === undefined) {
      control.handleChange("scientificName", "");
      initialValue = "";
    } else {
      initialValue = control.control.value.data;
    }
    const search = ref();

    const listData = ref();
    const loading = ref();

    if (initialValue !== "") {
      listData.value = [
        {
          title: initialValue,
          value: initialValue,
        },
      ];
    }

    const onInput = async (val) => {
      if (!val) return false;
      loading.value = true;
      const url = `https://www.ebi.ac.uk/ols4/api/v2/entities?search="${encodeURIComponent(val)}"&size=20&lang=en&exactMatch=false&includeObsoleteEntities=false&ontologyId=ncbitaxon`;

      try {
        const response = await fetch(url);
        const data = await response.json();
        const temp = [];
        for (const element of data.elements) {
          temp.push({
            title: element.label[0],
            value: `${element.curie.split(":")[1]}::${element.label[0]}`,
          });
        }

        listData.value = temp.sort((a, b) => {
          if (a.title.toLowerCase() < b.title.toLowerCase()) {
            return -1;
          }
          if (a.title.toLowerCase() > b.title.toLowerCase()) {
            return 1;
          }
          return 0;
        });
      } catch (error) {
        console.error("Erreur lors de la requête:", error);
      }
      loading.value = false;
    };

    return { ...control, onInput, loading, search, listData };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        // check for incorrect data
        return undefined;
      }
      return suggestions;
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("ncbi-taxon-sn"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-autocomplete
        :id="`${control.id}-input`"
        v-model:search-input="search"
        v-disabled-icon-focus
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        v-bind="vuetifyProps('v-autocomplete')"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :clearable="isHovering"
        :model-value="control.data"
        :items="listData"
        item-value="value"
        :loading="loading"
        @update:model-value="onChange"
        @update:search="onInput"
        @focus="handleFocus"
        @blur="handleBlur"
      />
    </VHover>
  </ControlWrapper>
</template>
